[tox]
envlist=py3
isolated_build = true

# The "_vars" section is ignored by tox but we place some useful shared
# variables in it to avoid needless repetition.
[_vars]
# Where to write build artefacts. We default to the "build" directory in the
# tox.ini file's directory. Override with the TOXINI_ARTEFACT_DIR environment
# variable.
build_root={env:TOXINI_ARTEFACT_DIR:{toxinidir}/build}

[testenv:py3]
basepython=python3
deps=
    poetry
commands_pre=
    # Install any developer-specific dependencies and all extras.
    poetry install --no-root --all-extras
commands=
    # Run the tests. Extra command line options are passed to pytest.
    pytest --doctest-modules --cov={toxinidir} --junitxml={[_vars]build_root}/{envname}/junit.xml {posargs}
commands_post=
    # Generate code coverage reports.
    coverage html --directory {[_vars]build_root}/{envname}/htmlcov/
    coverage xml -o {env:COVERAGE_XML_FILE:{[_vars]build_root}/{envname}/coverage.xml}
